<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible" width="800px">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="120px"
      v-loading="formLoading"
    >
      <el-form-item label="问卷名称" prop="bqQuestionnaire">
        <el-input v-model="formData.bqQuestionnaire" placeholder="请输入问卷名称" />
      </el-form-item>
      <el-form-item label="问卷介绍" prop="bqDetails">
        <Editor v-model="formData.bqDetails" height="150px" />
      </el-form-item>
      <el-form-item label="问卷排序" prop="bqOrder">
        <el-input-number v-model="formData.bqOrder" placeholder="请输入问卷排序" :min="0" clearable controls-position="right" class="!w-1/1" />
      </el-form-item>
      <el-form-item label="问卷开始指导语" prop="bqStartInfo">
        <Editor v-model="formData.bqStartInfo" height="150px" />
      </el-form-item>
      <el-form-item label="问卷结束指导语" prop="bqEndInfo">
        <Editor v-model="formData.bqEndInfo" height="150px" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { QuestionnaireApi, QuestionnaireVO } from '@/api/bjdx/questionnaire'

/** 问卷 表单 */
defineOptions({ name: 'QuestionnaireForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  bqQuestionnaire: undefined,
  bqDetails: undefined,
  bqOrder: undefined,
  bqStartInfo: undefined,
  bqEndInfo: undefined,
  bqQuestIds: undefined
})
const formRules = reactive({
  bqQuestionnaire: [{ required: true, message: '问卷名称不能为空', trigger: 'blur' }],
  bqOrder: [{ required: true, message: '问卷排序不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await QuestionnaireApi.getQuestionnaire(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as QuestionnaireVO
    if (formType.value === 'create') {
      await QuestionnaireApi.createQuestionnaire(data)
      message.success(t('common.createSuccess'))
    } else {
      await QuestionnaireApi.updateQuestionnaire(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    bqQuestionnaire: undefined,
    bqDetails: undefined,
    bqOrder: undefined,
    bqStartInfo: undefined,
    bqEndInfo: undefined,
    bqQuestIds: undefined
  }
  formRef.value?.resetFields()
}
</script>
